---
apiVersion: batch/v1
kind: CronJob
metadata:
  name: {{ include "ska-cicd-gitlab-metrics.fullname" . }}
  labels:
    {{- include "ska-cicd-gitlab-metrics.labels" . | nindent 4 }}
spec:
  schedule: "{{ .Values.schedule }}"
  jobTemplate:
    spec:
      backoffLimit: 1
      template:
        metadata:
          {{- with .Values.podAnnotations }}
          annotations:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          labels:
            {{- include "ska-cicd-gitlab-metrics.selectorLabels" . | nindent 12 }}
        spec:
          {{- with .Values.imagePullSecrets }}
          imagePullSecrets:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          serviceAccountName: {{ include "ska-cicd-gitlab-metrics.serviceAccountName" . }}
          securityContext:
            {{- toYaml .Values.podSecurityContext | nindent 12 }}
          restartPolicy: Never
          containers:
            - name: ska-cicd-gitlab-metrics
              securityContext:
                {{- toYaml .Values.securityContext | nindent 16 }}
              image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
              imagePullPolicy: {{ .Values.image.pullPolicy }}
              workingDir: /
              command:
              - /usr/local/bin/gitlab_metrics_scraper
              - --config
              - /etc/gitlab-metrics/gitlab-metrics.yml
              - --runonce
              env:
              - name: LOG_LEVEL
                value: "{{ .Values.env.log_level }}"
              - name: GITLAB_TOKEN
                value: "{{ .Values.env.gitlab_api_private_token }}"
              - name: RTD_TOKEN
                value: "{{ .Values.env.rtd_private_token }}"
              - name: RUN_ONCE
                value: "{{ .Values.env.run_once }}"
              resources:
                {{- toYaml .Values.resources | nindent 16 }}
              volumeMounts:
                - name: configuration
                  mountPath: /etc/gitlab-metrics
                  readOnly: true
          volumes:
            - name: configuration
              configMap:
                defaultMode: 0777
                name: {{ include "ska-cicd-gitlab-metrics.fullname" . }}
          {{- with .Values.nodeSelector }}
          nodeSelector:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with .Values.affinity }}
          affinity:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with .Values.tolerations }}
          tolerations:
            {{- toYaml . | nindent 12 }}
          {{- end }}
